Index: t3lib/class.t3lib_tcemain.php
===================================================================
--- t3lib/class.t3lib_tcemain.php	(revision 9580)
+++ t3lib/class.t3lib_tcemain.php	(revision )
@@ -4466,51 +4483,64 @@
 									$GLOBALS['TYPO3_DB']->sql_free_result($res);
 
 										// Look for version number of the current:
-									$subVer = $row['t3ver_id'].'.'.($highestVerNumber+1);
+									$subVer = $row['t3ver_id'] . '.' . ($highestVerNumber + 1);
 
 										// Set up the values to override when making a raw-copy:
 									$overrideArray = array(
-										't3ver_id' => $highestVerNumber+1,
+										't3ver_id' => $highestVerNumber + 1,
 										't3ver_oid' => $id,
-										't3ver_label' => ($label ? $label : $subVer.' / '.date('d-m-Y H:m:s')),
+										't3ver_label' => ($label ? $label : $subVer . ' / ' . date('d-m-Y H:m:s')),
 										't3ver_wsid' => $this->BE_USER->workspace,
 										't3ver_state' => $delete ? 2 : 0,
 										't3ver_count' => 0,
 										't3ver_stage' => 0,
 										't3ver_tstamp' => 0
 									);
-									if ($TCA[$table]['ctrl']['editlock'])	{
+									if ($TCA[$table]['ctrl']['editlock']) {
 										$overrideArray[$TCA[$table]['ctrl']['editlock']] = 0;
 									}
-									if ($table==='pages')	{
+									if ($table === 'pages') {
 										$overrideArray['t3ver_swapmode'] = $versionizeTree;
 									}
 
 										// Checking if the record already has a version in the current workspace of the backend user
 									$workspaceCheck = TRUE;
-									if ($this->BE_USER->workspace!==0)	{
+									if ($this->BE_USER->workspace !== 0) {
 											// Look for version already in workspace:
-										$workspaceCheck = t3lib_BEfunc::getWorkspaceVersionOfRecord($this->BE_USER->workspace,$table,$id,'uid') ? FALSE : TRUE;
+										$workspaceCheck = t3lib_BEfunc::getWorkspaceVersionOfRecord($this->BE_USER->workspace, $table, $id, 'uid') ? FALSE : TRUE;
 									}
 
-									if ($workspaceCheck)	{
+									if ($workspaceCheck) {
 
 											// Create raw-copy and return result:
-										return $this->copyRecord_raw($table,$id,-1,$overrideArray);
+										return $this->copyRecord_raw($table, $id, -1, $overrideArray);
-									} else $this->newlog('Record "'.$table.':'.$id.'" you wanted to versionize was already a version in the workspace (wsid='.$this->BE_USER->workspace.')!',1);
-								} else $this->newlog('Record cannot be deleted: '.$this->cannotDeleteRecord($table,$id),1);
-							} else $this->newlog('Record cannot be versioned because it is a placeholder for a moving operation',1);
-						} else $this->newlog('Record "'.$table.':'.$id.'" you wanted to versionize was already a version in archive (pid=-1)!',1);
-					} else $this->newlog('Record "'.$table.':'.$id.'" you wanted to versionize did not exist!',1);
-				} else $this->newlog('The versioning type '.$versionizeTree.' mode you requested was not allowed',1);
-			} else $this->newlog('You didnt have correct permissions to make a new version (copy) of this record "'.$table.'" / '.$id,1);
-		} else $this->newlog('Versioning is not supported for this table "'.$table.'" / '.$id,1);
+									} else {
+										$this->newlog('Record "' . $table . ':' . $id . '" you wanted to versionize was already a version in the workspace (wsid=' . $this->BE_USER->workspace . ')!', 1);
-	}
+									}
+								} else {
+									$this->newlog('Record cannot be deleted: ' . $this->cannotDeleteRecord($table, $id), 1);
+								}
+							} else {
+								$this->newlog('Record cannot be versioned because it is a placeholder for a moving operation', 1);
+							}
+						} else {
+							$this->newlog('Record "' . $table . ':' . $id . '" you wanted to versionize was already a version in archive (pid=-1)!', 1);
+						}
+					} else {
+						$this->newlog('Record "' . $table . ':' . $id . '" you wanted to versionize did not exist!', 1);
+					}
+				} else {
+					$this->newlog('The versioning type ' . $versionizeTree . ' mode you requested was not allowed', 1);
+				}
+			} else {
+				$this->newlog('You didnt have correct permissions to make a new version (copy) of this record "' . $table . '" / ' . $id, 1);
+			}
+		} else {
+			$this->newlog('Versioning is not supported for this table "' . $table . '" / ' . $id, 1);
+		}
+	}
 
 
-
-
-
 	/**
 	 * Swaps MM-relations for current/swap record, see version_swap()
 	 *
@@ -4520,50 +4550,50 @@
 	 * @return void
 	 * @see version_swap()
 	 */
-	function version_remapMMForVersionSwap($table,$id,$swapWith)	{
+	function version_remapMMForVersionSwap($table, $id, $swapWith) {
 		global $TCA;
 
 			// Actually, selecting the records fully is only need if flexforms are found inside... This could be optimized ...
-		$currentRec = t3lib_BEfunc::getRecord($table,$id);
+		$currentRec = t3lib_BEfunc::getRecord($table, $id);
-		$swapRec = t3lib_BEfunc::getRecord($table,$swapWith);
+		$swapRec = t3lib_BEfunc::getRecord($table, $swapWith);
 
 		$this->version_remapMMForVersionSwap_reg = array();
 
-		foreach($TCA[$table]['columns'] as $field => $fConf) {
+		foreach ($TCA[$table]['columns'] as $field => $fConf) {
 			$conf = $fConf['config'];
 
-			if ($this->isReferenceField($conf))	{
+			if ($this->isReferenceField($conf)) {
-				$allowedTables = $conf['type']=='group' ? $conf['allowed'] : $conf['foreign_table'].','.$conf['neg_foreign_table'];
+				$allowedTables = $conf['type'] == 'group' ? $conf['allowed'] : $conf['foreign_table'] . ',' . $conf['neg_foreign_table'];
-				$prependName = $conf['type']=='group' ? $conf['prepend_tname'] : $conf['neg_foreign_table'];
+				$prependName = $conf['type'] == 'group' ? $conf['prepend_tname'] : $conf['neg_foreign_table'];
-				if ($conf['MM'])	{
+				if ($conf['MM']) {
 
 					$dbAnalysis = t3lib_div::makeInstance('t3lib_loadDBGroup');
 					/* @var $dbAnalysis t3lib_loadDBGroup */
 					$dbAnalysis->start('', $allowedTables, $conf['MM'], $id, $table, $conf);
-					if (count($dbAnalysis->getValueArray($prependName)))	{
+					if (count($dbAnalysis->getValueArray($prependName))) {
 						$this->version_remapMMForVersionSwap_reg[$id][$field] = array($dbAnalysis, $conf['MM'], $prependName);
 					}
 
 					$dbAnalysis = t3lib_div::makeInstance('t3lib_loadDBGroup');
 					/* @var $dbAnalysis t3lib_loadDBGroup */
 					$dbAnalysis->start('', $allowedTables, $conf['MM'], $swapWith, $table, $conf);
-					if (count($dbAnalysis->getValueArray($prependName)))	{
+					if (count($dbAnalysis->getValueArray($prependName))) {
 						$this->version_remapMMForVersionSwap_reg[$swapWith][$field] = array($dbAnalysis, $conf['MM'], $prependName);
 					}
 				}
-			} elseif($conf['type']=='flex') {
+			} elseif ($conf['type'] == 'flex') {
 
 					// Current record
 				$dataStructArray = t3lib_BEfunc::getFlexFormDS($conf, $currentRec, $table);
 				$currentValueArray = t3lib_div::xml2array($currentRec[$field]);
 
-				if (is_array($currentValueArray))	{
+				if (is_array($currentValueArray)) {
 					$this->checkValue_flex_procInData(
 						$currentValueArray['data'],
-						array(),	// Not used.
+						array(), // Not used.
-						array(),	// Not used.
+						array(), // Not used.
 						$dataStructArray,
-						array($table,$id,$field),	// Parameters.
+						array($table, $id, $field), // Parameters.
 						'version_remapMMForVersionSwap_flexFormCallBack'
 					);
 				}
@@ -4572,13 +4602,13 @@
 				$dataStructArray = t3lib_BEfunc::getFlexFormDS($conf, $swapRec, $table);
 				$currentValueArray = t3lib_div::xml2array($swapRec[$field]);
 
-				if (is_array($currentValueArray))	{
+				if (is_array($currentValueArray)) {
 					$this->checkValue_flex_procInData(
 						$currentValueArray['data'],
-						array(),	// Not used.
+						array(), // Not used.
-						array(),	// Not used.
+						array(), // Not used.
 						$dataStructArray,
-						array($table,$swapWith,$field),	// Parameters.
+						array($table, $swapWith, $field), // Parameters.
 						'version_remapMMForVersionSwap_flexFormCallBack'
 					);
 				}
@@ -4586,7 +4616,7 @@
 		}
 
 			// Execute:
-		$this->version_remapMMForVersionSwap_execSwap($table,$id,$swapWith);
+		$this->version_remapMMForVersionSwap_execSwap($table, $id, $swapWith);
 	}
 
 	/**
@@ -4601,19 +4631,19 @@
 	 * @return	array		Result array with key "value" containing the value of the processing.
 	 * @see version_remapMMForVersionSwap(), checkValue_flex_procInData_travDS()
 	 */
-	function version_remapMMForVersionSwap_flexFormCallBack($pParams, $dsConf, $dataValue, $dataValue_ext1, $dataValue_ext2, $path)	{
+	function version_remapMMForVersionSwap_flexFormCallBack($pParams, $dsConf, $dataValue, $dataValue_ext1, $dataValue_ext2, $path) {
 
 			// Extract parameters:
 		list($table, $uid, $field) = $pParams;
 
 		if ($this->isReferenceField($dsConf)) {
-			$allowedTables = $dsConf['type']=='group' ? $dsConf['allowed'] : $dsConf['foreign_table'].','.$dsConf['neg_foreign_table'];
+			$allowedTables = $dsConf['type'] == 'group' ? $dsConf['allowed'] : $dsConf['foreign_table'] . ',' . $dsConf['neg_foreign_table'];
-			$prependName = $dsConf['type']=='group' ? $dsConf['prepend_tname'] : $dsConf['neg_foreign_table'];
+			$prependName = $dsConf['type'] == 'group' ? $dsConf['prepend_tname'] : $dsConf['neg_foreign_table'];
-			if ($dsConf['MM'])	{
+			if ($dsConf['MM']) {
 				$dbAnalysis = t3lib_div::makeInstance('t3lib_loadDBGroup');
 				/* @var $dbAnalysis t3lib_loadDBGroup */
 				$dbAnalysis->start('', $allowedTables, $dsConf['MM'], $uid, $table, $dsConf);
-				$this->version_remapMMForVersionSwap_reg[$uid][$field.'/'.$path] = array($dbAnalysis, $dsConf['MM'], $prependName);
+				$this->version_remapMMForVersionSwap_reg[$uid][$field . '/' . $path] = array($dbAnalysis, $dsConf['MM'], $prependName);
 			}
 		}
 	}
@@ -4628,37 +4658,28 @@
 	 * @return void
 	 * @see version_remapMMForVersionSwap()
 	 */
-	function version_remapMMForVersionSwap_execSwap($table,$id,$swapWith)	{
+	function version_remapMMForVersionSwap_execSwap($table, $id, $swapWith) {
 
-		if (is_array($this->version_remapMMForVersionSwap_reg[$id]))	{
+		if (is_array($this->version_remapMMForVersionSwap_reg[$id])) {
-			foreach($this->version_remapMMForVersionSwap_reg[$id] as $field => $str)	{
+			foreach ($this->version_remapMMForVersionSwap_reg[$id] as $field => $str) {
-				$str[0]->remapMM($str[1],$id,-$id,$str[2]);
+				$str[0]->remapMM($str[1], $id, -$id, $str[2]);
 			}
 		}
 
-		if (is_array($this->version_remapMMForVersionSwap_reg[$swapWith]))	{
+		if (is_array($this->version_remapMMForVersionSwap_reg[$swapWith])) {
-			foreach($this->version_remapMMForVersionSwap_reg[$swapWith] as $field => $str)	{
+			foreach ($this->version_remapMMForVersionSwap_reg[$swapWith] as $field => $str) {
-				$str[0]->remapMM($str[1],$swapWith,$id,$str[2]);
+				$str[0]->remapMM($str[1], $swapWith, $id, $str[2]);
 			}
 		}
 
-		if (is_array($this->version_remapMMForVersionSwap_reg[$id]))	{
+		if (is_array($this->version_remapMMForVersionSwap_reg[$id])) {
-			foreach($this->version_remapMMForVersionSwap_reg[$id] as $field => $str)	{
+			foreach ($this->version_remapMMForVersionSwap_reg[$id] as $field => $str) {
-				$str[0]->remapMM($str[1],-$id,$swapWith,$str[2]);
+				$str[0]->remapMM($str[1], -$id, $swapWith, $str[2]);
 			}
 		}
 	}
 
 
-
-
-
-
-
-
-
-
-
 	/*********************************************
 	 *
 	 * Cmd: Helper functions
@@ -4670,34 +4691,34 @@
 	 *
 	 * @return	void
 	 */
-	function remapListedDBRecords()	{
+	function remapListedDBRecords() {
 		global $TCA;
 
-		if (count($this->registerDBList))	{
+		if (count($this->registerDBList)) {
 			foreach ($this->registerDBList as $table => $records) {
 				t3lib_div::loadTCA($table);
 				foreach ($records as $uid => $fields) {
 					$newData = array();
 					$theUidToUpdate = $this->copyMappingArray_merged[$table][$uid];
-					$theUidToUpdate_saveTo = t3lib_BEfunc::wsMapId($table,$theUidToUpdate);
+					$theUidToUpdate_saveTo = t3lib_BEfunc::wsMapId($table, $theUidToUpdate);
 
-					foreach($fields as $fieldName => $value)	{
+					foreach ($fields as $fieldName => $value) {
 						$conf = $TCA[$table]['columns'][$fieldName]['config'];
 
-						switch($conf['type'])	{
+						switch ($conf['type']) {
 							case 'group':
 							case 'select':
 								$vArray = $this->remapListedDBRecords_procDBRefs($conf, $value, $theUidToUpdate, $table);
-								if (is_array($vArray))	{
+								if (is_array($vArray)) {
-									$newData[$fieldName] = implode(',',$vArray);
+									$newData[$fieldName] = implode(',', $vArray);
 								}
 							break;
 							case 'flex':
-								if ($value=='FlexForm_reference')	{
+								if ($value == 'FlexForm_reference') {
-									$origRecordRow = $this->recordInfo($table,$theUidToUpdate,'*');	// This will fetch the new row for the element
+									$origRecordRow = $this->recordInfo($table, $theUidToUpdate, '*'); // This will fetch the new row for the element
 
-									if (is_array($origRecordRow))	{
+									if (is_array($origRecordRow)) {
-										t3lib_BEfunc::workspaceOL($table,$origRecordRow);
+										t3lib_BEfunc::workspaceOL($table, $origRecordRow);
 
 											// Get current data structure and value array:
 										$dataStructArray = t3lib_BEfunc::getFlexFormDS($conf, $origRecordRow, $table);
@@ -4705,18 +4726,18 @@
 
 											// Do recursive processing of the XML data:
 										$currentValueArray['data'] = $this->checkValue_flex_procInData(
-													$currentValueArray['data'],
+											$currentValueArray['data'],
-													array(),	// Not used.
+											array(), // Not used.
-													array(),	// Not used.
+											array(), // Not used.
-													$dataStructArray,
+											$dataStructArray,
-													array($table,$theUidToUpdate,$fieldName),	// Parameters.
+											array($table, $theUidToUpdate, $fieldName), // Parameters.
-													'remapListedDBRecords_flexFormCallBack'
-												);
+											'remapListedDBRecords_flexFormCallBack'
+										);
 
 											// The return value should be compiled back into XML, ready to insert directly in the field (as we call updateDB() directly later):
-										if (is_array($currentValueArray['data']))	{
+										if (is_array($currentValueArray['data'])) {
 											$newData[$fieldName] =
-												$this->checkValue_flexArray2Xml($currentValueArray,TRUE);
+													$this->checkValue_flexArray2Xml($currentValueArray, TRUE);
 										}
 									}
 								}
@@ -4725,13 +4746,13 @@
 								$this->remapListedDBRecords_procInline($conf, $value, $uid, $table);
 							break;
 							default:
-								debug('Field type should not appear here: '. $conf['type']);
+								debug('Field type should not appear here: ' . $conf['type']);
 							break;
 						}
 					}
 
-					if (count($newData))	{	// If any fields were changed, those fields are updated!
+					if (count($newData)) { // If any fields were changed, those fields are updated!
-						$this->updateDB($table,$theUidToUpdate_saveTo,$newData);
+						$this->updateDB($table, $theUidToUpdate_saveTo, $newData);
 					}
 				}
 			}
@@ -4749,16 +4770,16 @@
 	 * @return	array		Array where the "value" key carries the value.
 	 * @see checkValue_flex_procInData_travDS(), remapListedDBRecords()
 	 */
-	function remapListedDBRecords_flexFormCallBack($pParams, $dsConf, $dataValue, $dataValue_ext1, $dataValue_ext2)	{
+	function remapListedDBRecords_flexFormCallBack($pParams, $dsConf, $dataValue, $dataValue_ext1, $dataValue_ext2) {
 
 			// Extract parameters:
-		list($table,$uid,$field)	= $pParams;
+		list($table, $uid, $field) = $pParams;
 
 			// If references are set for this field, set flag so they can be corrected later:
 		if ($this->isReferenceField($dsConf) && strlen($dataValue)) {
 			$vArray = $this->remapListedDBRecords_procDBRefs($dsConf, $dataValue, $uid, $table);
-			if (is_array($vArray))	{
+			if (is_array($vArray)) {
-				$dataValue = implode(',',$vArray);
+				$dataValue = implode(',', $vArray);
 			}
 		}
 
@@ -4776,35 +4797,35 @@
 	 * @return	array		Returns array of items ready to implode for field content.
 	 * @see remapListedDBRecords()
 	 */
-	function remapListedDBRecords_procDBRefs($conf, $value, $MM_localUid, $table)	{
+	function remapListedDBRecords_procDBRefs($conf, $value, $MM_localUid, $table) {
 
 			// Initialize variables
-		$set = FALSE;	// Will be set true if an upgrade should be done...
+		$set = FALSE; // Will be set true if an upgrade should be done...
-		$allowedTables = $conf['type']=='group' ? $conf['allowed'] : $conf['foreign_table'].','.$conf['neg_foreign_table'];		// Allowed tables for references.
+		$allowedTables = $conf['type'] == 'group' ? $conf['allowed'] : $conf['foreign_table'] . ',' . $conf['neg_foreign_table']; // Allowed tables for references.
-		$prependName = $conf['type']=='group' ? $conf['prepend_tname'] : '';	// Table name to prepend the UID
+		$prependName = $conf['type'] == 'group' ? $conf['prepend_tname'] : ''; // Table name to prepend the UID
-		$dontRemapTables = t3lib_div::trimExplode(',',$conf['dontRemapTablesOnCopy'],1);	// Which tables that should possibly not be remapped
+		$dontRemapTables = t3lib_div::trimExplode(',', $conf['dontRemapTablesOnCopy'], 1); // Which tables that should possibly not be remapped
 
 			// Convert value to list of references:
 		$dbAnalysis = t3lib_div::makeInstance('t3lib_loadDBGroup');
-		$dbAnalysis->registerNonTableValues = ($conf['type']=='select' && $conf['allowNonIdValues']) ? 1 : 0;
+		$dbAnalysis->registerNonTableValues = ($conf['type'] == 'select' && $conf['allowNonIdValues']) ? 1 : 0;
 		$dbAnalysis->start($value, $allowedTables, $conf['MM'], $MM_localUid, $table, $conf);
 
 			// Traverse those references and map IDs:
-		foreach($dbAnalysis->itemArray as $k => $v)	{
+		foreach ($dbAnalysis->itemArray as $k => $v) {
 			$mapID = $this->copyMappingArray_merged[$v['table']][$v['id']];
-			if ($mapID && !in_array($v['table'],$dontRemapTables))	{
+			if ($mapID && !in_array($v['table'], $dontRemapTables)) {
 				$dbAnalysis->itemArray[$k]['id'] = $mapID;
 				$set = TRUE;
 			}
 		}
 
 			// If a change has been done, set the new value(s)
-		if ($set)	{
+		if ($set) {
-			if ($conf['MM'])	{
+			if ($conf['MM']) {
 				$dbAnalysis->writeMM($conf['MM'], $MM_localUid, $prependName);
 			} else {
 				$vArray = $dbAnalysis->getValueArray($prependName);
-				if ($conf['type']=='select')	{
+				if ($conf['type'] == 'select') {
 					$vArray = $dbAnalysis->convertPosNeg($vArray, $conf['foreign_table'], $conf['neg_foreign_table']);
 				}
 				return $vArray;
@@ -4830,7 +4851,7 @@
 			if ($inlineType == 'mm') {
 				$this->remapListedDBRecords_procDBRefs($conf, $value, $theUidToUpdate, $table);
 
-			} elseif ($inlineType !== false) {
+			} elseif ($inlineType !== FALSE) {
 				/** @var $dbAnalysis t3lib_loadDBGroup */
 				$dbAnalysis = t3lib_div::makeInstance('t3lib_loadDBGroup');
 				$dbAnalysis->start($value, $conf['foreign_table'], '', 0, $table, $conf);
@@ -4854,7 +4875,7 @@
 					$updateValues = array('pid' => $thePidToUpdate);
 					foreach ($dbAnalysis->itemArray as $v) {
 						if ($v['id'] && $v['table'] && is_null(t3lib_BEfunc::getLiveVersionIdOfRecord($v['table'], $v['id']))) {
-							$GLOBALS['TYPO3_DB']->exec_UPDATEquery($v['table'], 'uid='.intval($v['id']), $updateValues);
+							$GLOBALS['TYPO3_DB']->exec_UPDATEquery($v['table'], 'uid=' . intval($v['id']), $updateValues);
 						}
 					}
 				}
@@ -4870,10 +4891,12 @@
 	 */
 	function processRemapStack() {
 			// Processes the remap stack:
-		if(is_array($this->remapStack)) {
+		if (is_array($this->remapStack)) {
-			foreach($this->remapStack as $remapAction) {
+			foreach ($this->remapStack as $remapAction) {
 					// If no position index for the arguments was set, skip this remap action:
-				if (!is_array($remapAction['pos'])) continue;
+				if (!is_array($remapAction['pos'])) {
+					continue;
+				}
 
 					// Load values from the argument array in remapAction:
 				$field = $remapAction['field'];
@@ -4884,7 +4907,7 @@
 				$tcaFieldConf = $remapAction['args'][$remapAction['pos']['tcaFieldConf']];
 
 					// The record is new and has one or more new ids (in case of versioning/workspaces):
-				if(strpos($id, 'NEW') !== false) {
+				if (strpos($id, 'NEW') !== FALSE) {
 						// Replace NEW...-ID with real uid:
 					$id = $this->substNEWwithIDs[$id];
 
@@ -4896,10 +4919,10 @@
 				}
 
 					// Replace relations to NEW...-IDs in field value (uids of child records):
-				if(is_array($valueArray)) {
+				if (is_array($valueArray)) {
 					$foreign_table = $tcaFieldConf['foreign_table'];
-					foreach($valueArray as $key => $value) {
+					foreach ($valueArray as $key => $value) {
-						if(strpos($value, 'NEW') !== false) {
+						if (strpos($value, 'NEW') !== FALSE) {
 							$value = $this->substNEWwithIDs[$value];
 								// The record is new, but was also auto-versionized and has another new id:
 							if (isset($this->autoVersionIdMap[$foreign_table][$value])) {
@@ -4931,7 +4954,7 @@
 					$hookArgs['fieldArray'][$field] = $newValue;
 						// Process waiting hook objects:
 					$hookObjectsArr = $hookArgs['hookObjectsArr'];
-					foreach($hookObjectsArr as $hookObj)	{
+					foreach ($hookObjectsArr as $hookObj) {
 						if (method_exists($hookObj, 'processDatamap_afterDatabaseOperations')) {
 							$hookObj->processDatamap_afterDatabaseOperations($hookArgs['status'], $table, $rawId, $hookArgs['fieldArray'], $this);
 						}
@@ -4964,7 +4987,7 @@
 		$this->remapStackRefIndex = array();
 	}
 
- 	/**
+	/**
 	 * Triggers a remap action for a specific record.
 	 *
 	 * Some records are post-processed by the processRemapStack() method (e.g. IRRE children).
@@ -4973,7 +4996,7 @@
 	 *
 	 * @param string $table Name of the table
 	 * @param string $id Id of the record (can also be a "NEW..." string)
- 	 * @param array $callback The method to be called
+	 * @param array $callback The method to be called
 	 * @param array $arguments The arguments to be submitted to the callback method
 	 * @param boolean $forceRemapStackActions Whether to force to use the stack
 	 * @return void
@@ -5017,7 +5040,7 @@
 	 * @param	integer		$id: Uid of the parent record
 	 * @param	array		$incomingFieldArray: Reference to the incominfFieldArray of process_datamap
 	 * @param	array		$registerDBList: Reference to the $registerDBList array that was created/updated by versionizing calls to TCEmain in process_datamap.
-	 * @return 	void
+	 * @return	 void
 	 */
 	function getVersionizedIncomingFieldArray($table, $id, &$incomingFieldArray, &$registerDBList) {
 		if (is_array($registerDBList[$table][$id])) {
@@ -5029,8 +5052,8 @@
 						// Update the uids of the copied records, but also take care about new records:
 					foreach ($origValueArray as $childId) {
 						$newValueArray[] = $this->autoVersionIdMap[$foreignTable][$childId]
-							? $this->autoVersionIdMap[$foreignTable][$childId]
-							: $childId;
+								? $this->autoVersionIdMap[$foreignTable][$childId]
+								: $childId;
 					}
 						// Set the changed value to the $incomingFieldArray
 					$incomingFieldArray[$field] = implode(',', $newValueArray);
@@ -5038,18 +5061,13 @@
 			}
 				// Clean up the $registerDBList array:
 			unset($registerDBList[$table][$id]);
-			if (!count($registerDBList[$table])) unset($registerDBList[$table]);
+			if (!count($registerDBList[$table])) {
+				unset($registerDBList[$table]);
-		}
-	}
+			}
+		}
+	}
 
 
-
-
-
-
-
-
-
 	/*****************************
 	 *
 	 * Access control / Checking functions
@@ -5062,11 +5080,11 @@
 	 * @param	string		Table name
 	 * @return	boolean		Returns true if the user has general access to modify the $table
 	 */
-	function checkModifyAccessList($table)	{
+	function checkModifyAccessList($table) {
-		$res = ($this->admin || (!$this->tableAdminOnly($table) && t3lib_div::inList($this->BE_USER->groupData['tables_modify'],$table)));
+		$res = ($this->admin || (!$this->tableAdminOnly($table) && t3lib_div::inList($this->BE_USER->groupData['tables_modify'], $table)));
 
 			// Hook 'checkModifyAccessList': Post-processing of the state of access
-		foreach($this->getCheckModifyAccessListHookObjects() as $hookObject) {
+		foreach ($this->getCheckModifyAccessListHookObjects() as $hookObject) {
 			/* @var $hookObject t3lib_TCEmain_checkModifyAccessListHook */
 			$hookObject->checkModifyAccessList($res, $table, $this);
 		}
@@ -5081,12 +5099,12 @@
 	 * @param	integer		UID of record
 	 * @return	boolean		Returns true if OK. Cached results.
 	 */
-	function isRecordInWebMount($table,$id)	{
+	function isRecordInWebMount($table, $id) {
-		if (!isset($this->isRecordInWebMount_Cache[$table.':'.$id]))	{
+		if (!isset($this->isRecordInWebMount_Cache[$table . ':' . $id])) {
-			$recP=$this->getRecordProperties($table,$id);
+			$recP = $this->getRecordProperties($table, $id);
-			$this->isRecordInWebMount_Cache[$table.':'.$id]=$this->isInWebMount($recP['event_pid']);
+			$this->isRecordInWebMount_Cache[$table . ':' . $id] = $this->isInWebMount($recP['event_pid']);
 		}
-		return $this->isRecordInWebMount_Cache[$table.':'.$id];
+		return $this->isRecordInWebMount_Cache[$table . ':' . $id];
 	}
 
 	/**
@@ -5095,9 +5113,9 @@
 	 * @param	integer		Page ID to check
 	 * @return	boolean		True if OK. Cached results.
 	 */
-	function isInWebMount($pid)	{
+	function isInWebMount($pid) {
-		if (!isset($this->isInWebMount_Cache[$pid]))	{
+		if (!isset($this->isInWebMount_Cache[$pid])) {
-			$this->isInWebMount_Cache[$pid]=$this->BE_USER->isInWebMount($pid);
+			$this->isInWebMount_Cache[$pid] = $this->BE_USER->isInWebMount($pid);
 		}
 		return $this->isInWebMount_Cache[$pid];
 	}
@@ -5111,30 +5129,30 @@
 	 * @param	array		Hook objects
 	 * @return	boolean		Returns true if the user may update the record given by $table and $id
 	 */
-	function checkRecordUpdateAccess($table, $id, $data=false, &$hookObjectsArr = false) {
+	function checkRecordUpdateAccess($table, $id, $data = FALSE, &$hookObjectsArr = FALSE) {
 		global $TCA;
 		$res = NULL;
 		if (is_array($hookObjectsArr)) {
-			foreach($hookObjectsArr as $hookObj) {
+			foreach ($hookObjectsArr as $hookObj) {
 				if (method_exists($hookObj, 'checkRecordUpdateAccess')) {
 					$res = $hookObj->checkRecordUpdateAccess($table, $id, $data, $res, $this);
 				}
 			}
 		}
-		if($res === 1 || $res === 0) {
+		if ($res === 1 || $res === 0) {
 			return $res;
 		} else {
 			$res = 0;
 		}
 
-		if ($TCA[$table] && intval($id)>0)	{
+		if ($TCA[$table] && intval($id) > 0) {
-			if (isset($this->recUpdateAccessCache[$table][$id]))	{	// If information is cached, return it
+			if (isset($this->recUpdateAccessCache[$table][$id])) { // If information is cached, return it
 				return $this->recUpdateAccessCache[$table][$id];
 				// Check if record exists and 1) if 'pages' the page may be edited, 2) if page-content the page allows for editing
-			} elseif ($this->doesRecordExist($table,$id,'edit'))	{
+			} elseif ($this->doesRecordExist($table, $id, 'edit')) {
 				$res = 1;
 			}
-			$this->recUpdateAccessCache[$table][$id]=$res;	// Cache the result
+			$this->recUpdateAccessCache[$table][$id] = $res; // Cache the result
 		}
 		return $res;
 	}
@@ -5148,27 +5166,27 @@
 	 * @param	integer		For logging: Action number.
 	 * @return	boolean		Returns true if the user may insert a record from table $insertTable on page $pid
 	 */
-	function checkRecordInsertAccess($insertTable,$pid,$action=1)	{
+	function checkRecordInsertAccess($insertTable, $pid, $action = 1) {
 		global $TCA;
 
 		$res = 0;
 		$pid = intval($pid);
-		if ($pid>=0)	{
+		if ($pid >= 0) {
-			if (isset($this->recInsertAccessCache[$insertTable][$pid]))	{	// If information is cached, return it
+			if (isset($this->recInsertAccessCache[$insertTable][$pid])) { // If information is cached, return it
 				return $this->recInsertAccessCache[$insertTable][$pid];
 			} else {
 					// If either admin and root-level or if page record exists and 1) if 'pages' you may create new ones 2) if page-content, new content items may be inserted on the $pid page
-				if ( (!$pid && $this->admin) || $this->doesRecordExist('pages',$pid,($insertTable=='pages'?$this->pMap['new']:$this->pMap['editcontent'])) )	{		// Check permissions
+				if ((!$pid && $this->admin) || $this->doesRecordExist('pages', $pid, ($insertTable == 'pages' ? $this->pMap['new'] : $this->pMap['editcontent']))) { // Check permissions
-					if ($this->isTableAllowedForThisPage($pid, $insertTable))	{
+					if ($this->isTableAllowedForThisPage($pid, $insertTable)) {
 						$res = 1;
-						$this->recInsertAccessCache[$insertTable][$pid]=$res;	// Cache the result
+						$this->recInsertAccessCache[$insertTable][$pid] = $res; // Cache the result
 					} else {
-						$propArr = $this->getRecordProperties('pages',$pid);
+						$propArr = $this->getRecordProperties('pages', $pid);
-						$this->log($insertTable,$pid,$action,0,1,"Attempt to insert record on page '%s' (%s) where this table, %s, is not allowed",11,array($propArr['header'],$pid,$insertTable),$propArr['event_pid']);
+						$this->log($insertTable, $pid, $action, 0, 1, "Attempt to insert record on page '%s' (%s) where this table, %s, is not allowed", 11, array($propArr['header'], $pid, $insertTable), $propArr['event_pid']);
 					}
 				} else {
-					$propArr = $this->getRecordProperties('pages',$pid);
+					$propArr = $this->getRecordProperties('pages', $pid);
-					$this->log($insertTable,$pid,$action,0,1,"Attempt to insert a record on page '%s' (%s) from table '%s' without permissions. Or non-existing page.",12,array($propArr['header'],$pid,$insertTable),$propArr['event_pid']);
+					$this->log($insertTable, $pid, $action, 0, 1, "Attempt to insert a record on page '%s' (%s) from table '%s' without permissions. Or non-existing page.", 12, array($propArr['header'], $pid, $insertTable), $propArr['event_pid']);
 				}
 			}
 		}
@@ -5182,27 +5200,27 @@
 	 * @param	string		Table name to check
 	 * @return	boolean		True if OK
 	 */
-	function isTableAllowedForThisPage($page_uid, $checkTable)	{
+	function isTableAllowedForThisPage($page_uid, $checkTable) {
 		global $TCA, $PAGES_TYPES;
 		$page_uid = intval($page_uid);
 
 			// Check if rootLevel flag is set and we're trying to insert on rootLevel - and reversed - and that the table is not "pages" which are allowed anywhere.
-		if (($TCA[$checkTable]['ctrl']['rootLevel'] xor !$page_uid) && $TCA[$checkTable]['ctrl']['rootLevel']!=-1 && $checkTable!='pages')	{
+		if (($TCA[$checkTable]['ctrl']['rootLevel'] xor !$page_uid) && $TCA[$checkTable]['ctrl']['rootLevel'] != -1 && $checkTable != 'pages') {
-			return false;
+			return FALSE;
 		}
 
 			// Check root-level
-		if (!$page_uid)	{
+		if (!$page_uid) {
-			if ($this->admin)	{
+			if ($this->admin) {
-				return true;
+				return TRUE;
 			}
 		} else {
 				// Check non-root-level
-			$doktype = $this->pageInfo($page_uid,'doktype');
+			$doktype = $this->pageInfo($page_uid, 'doktype');
 			$allowedTableList = isset($PAGES_TYPES[$doktype]['allowedTables']) ? $PAGES_TYPES[$doktype]['allowedTables'] : $PAGES_TYPES['default']['allowedTables'];
-			$allowedArray = t3lib_div::trimExplode(',',$allowedTableList,1);
+			$allowedArray = t3lib_div::trimExplode(',', $allowedTableList, 1);
-			if (strstr($allowedTableList,'*') || in_array($checkTable,$allowedArray))	{		// If all tables or the table is listed as a allowed type, return true
+			if (strstr($allowedTableList, '*') || in_array($checkTable, $allowedArray)) { // If all tables or the table is listed as a allowed type, return true
-				return true;
+				return TRUE;
 			}
 		}
 	}
